﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

	public class TextController : MonoBehaviour {
	
	public Text text;
	
	private enum States {
		cell, mirror, sheets_0, lock_0, cell_mirror, sheets_1, lock_1, 
		corridor_0, stair_0, stair_1, stair_2, floor, corridor_1, 
		corridor_2, corridor_3, courtyard, closet_door, in_closet, in_closet_0
		};
	private States myState;

	void Start () {myState = States.cell;}
	
	void Update () {
		print 	(myState);
		if 		(myState == States.cell)		{cell ();} 
		else if (myState == States.sheets_0) 	{sheets_0 ();} 
		else if (myState == States.lock_0)		{lock_0 ();}
		else if (myState == States.sheets_1)	{sheets_1 ();}
		else if (myState == States.lock_1)		{lock_1 ();}
		else if (myState == States.mirror)		{mirror ();}
		else if (myState == States.cell_mirror)	{cell_mirror ();}
		else if (myState == States.corridor_0)	{corridor_0 ();}
		else if (myState == States.corridor_1)	{corridor_1 ();}
		else if (myState == States.corridor_2)	{corridor_2 ();}
		else if (myState == States.corridor_3)	{corridor_3 ();}
		else if (myState == States.stair_0)		{stair_0 ();}
		else if (myState == States.stair_1)		{stair_1 ();}
		else if (myState == States.stair_2)		{stair_2 ();}
		else if (myState == States.floor)		{floor ();}
		else if (myState == States.courtyard)	{courtyard ();}
		else if (myState == States.closet_door) {closet_door ();}
		else if (myState == States.in_closet)	{in_closet ();}
		else if (myState == States.in_closet_0)	{in_closet_0 ();}
	}
	#region state handler methods 
	void cell (){
		text.text = "You are in a prison cell, and you want to escape. " +
					"There are some dirty sheets on the bed, a mirror on " +
					"the wall, and the door is locked from the outside.\n\n" +
					"Press S to view Sheets, M to view mirror and L to view Lock.";
		if 		(Input.GetKeyDown (KeyCode.S))		{myState = States.sheets_0;}
		else if (Input.GetKeyDown (KeyCode.M))		{myState = States.mirror;}
		else if (Input.GetKeyDown (KeyCode.L))		{myState = States.lock_0;}				
	}
	void sheets_0 (){
		text.text = "You cant belive you sleep in these things. Surely it's " +
					"time somebody changed them. The pleasures of prison life " +
					"I guess!\n\n" +
					"Press R to Return to roaming your cell";
		if 		(Input.GetKeyDown (KeyCode.R))		{myState = States.cell;}				
	}
	void lock_0 (){
		text.text = "This is one of those button locks. You have no idea what the " +
					"combination is. You wish you could somehow see where the dirty " +
					"fingerprints were, maybe that would help.\n\n" +
					"Press R to Return to roaming your cell" ;
		if 		(Input.GetKeyDown (KeyCode.R))		{myState = States.cell;}			
	}
	void mirror (){
		text.text = "The dirty old mirror on the wall seems loose.\n\n" +
					"Press T to Take the mirror, or R to Return to cell" ;
		if 		(Input.GetKeyDown (KeyCode.T))	{myState = States.cell_mirror;}
		else if (Input.GetKeyDown (KeyCode.R))	{myState = States.cell;}
	}
	void lock_1 (){
		text.text = "You carefully put the mirror through the bars, and turn it round " +
					"so you can see the lock. you can just make out fingerprints around " +
					"the buttons. You press the dirty buttons, and hear a click.\n\n" +
					"Press O to Open, or R to Return to roaming your cell";
		if 		(Input.GetKeyDown (KeyCode.O))		{myState = States.corridor_0;}	
		else if (Input.GetKeyDown (KeyCode.R))		{myState = States.cell_mirror;}
	}
	void sheets_1 (){
		text.text = "Holding a mirror in your hand doesn't make the sheets look " +
					"any better.\n\n" +
					"Press R to Return to roaming your cell" ;
		if 		(Input.GetKeyDown (KeyCode.R))		{myState = States.cell_mirror;}				
	}
	void cell_mirror (){
		text.text = "You are still in your cell, and you STILL want to escape! There are " +
					"some dirty sheets on the bed, a mark where the mirror was, " +
					"and that pesky door is still there, and firmly locked!\n\n" +
					"Press S to view Sheets, or L to view Lock" ;
		if 		(Input.GetKeyDown (KeyCode.S))	{myState = States.sheets_1;}
		else if (Input.GetKeyDown (KeyCode.L))	{myState = States.lock_1;}
	}
	void corridor_0 (){
			text.text = "You are now in a corridor. There is a stair way going up, " +
						"something shinning on the floor, and a closet.\n\n" +
						"Press S to go up the stairs, F to view the floor, or C to view the Closet door";
		if 		(Input.GetKeyDown (KeyCode.S))	{myState = States.stair_0;}
		else if (Input.GetKeyDown (KeyCode.F))	{myState = States.floor;}
		else if (Input.GetKeyDown (KeyCode.C))	{myState = States.closet_door;}
		
	}
	void stair_0 (){
		text.text = "Seems like there is a guard up stairs. Better to turn back and " +
					"avoid getting caught.\n\n" +
					"Press R to return back to the corridor.";
		if 		(Input.GetKeyDown (KeyCode.R))	{myState = States.corridor_0;}
	}
	void floor (){
		text.text = "There is a paper clip fallen on the floor, could be of some use later.\n\n" +
					"Press P to pickup the pin or R to return back to the corridor.";
		if 		(Input.GetKeyDown (KeyCode.P))	{myState = States.corridor_1;}
		else if (Input.GetKeyDown (KeyCode.R))	{myState = States.corridor_0;}
	}
	void closet_door (){
		text.text = "The door seems to be locked... I wonder whats in it.\n\n" +
					"Press R to return back to the corridor.";
		if 		(Input.GetKeyDown (KeyCode.R))	{myState = States.corridor_0;}
	}
	void corridor_1 (){
		text.text = "You shouldnt waste time. Find a way to get pass the guard upstairs.\n\n" +
					"Press S to go up the stairs, or C to view the Closet door";
		if 		(Input.GetKeyDown (KeyCode.S))	{myState = States.stair_1;}
		else if (Input.GetKeyDown (KeyCode.C))	{myState = States.in_closet;}
	}
	void stair_1 (){
		text.text = "The guard is still upstairs, you still haven't found a way to get past the guard.\n\n" +
					"Press R to return back to the corridor.";
		if 		(Input.GetKeyDown (KeyCode.R))	{myState = States.corridor_1;}
	}
	void in_closet (){
		text.text = "You use the paper clip to open the closet door, and find that there are " +
					"only old uniforms which the guards wear in here. And a broken whistle.\n\n" +
					"Press R to return back to the corridor.";
		if 		(Input.GetKeyDown (KeyCode.R))	{myState = States.corridor_2;}
	}
	void corridor_2 (){
		text.text = "You are still at the corridor, and have not found a way yet to pass the guard.\n\n" +
					"Press S to go up the stairs and see if the guard is still there.";
		if 		(Input.GetKeyDown (KeyCode.S))	{myState = States.stair_2;}
	}
	void stair_2 (){
		text.text = "The guard has not moved yet. Seems like he is not going to move from there. \n\n" +
					"Press R to return back to the corridor.";
		if 		(Input.GetKeyDown (KeyCode.R))	{myState = States.corridor_3;}
	}
	void corridor_3 (){
		text.text = "you got an idea! You decide to use what you found in the closet to your advantage.\n\n" +
					"Press S to go up the stairs and check on the guard, or C to view the Closet door";
		if 		(Input.GetKeyDown (KeyCode.S))	{myState = States.stair_2;}
		else if (Input.GetKeyDown (KeyCode.C))	{myState = States.in_closet_0;}
	}
	void in_closet_0 (){
		text.text = "You use the paper clip to open the closet door, and find that there are " +
					"only old uniforms which the guards wear in here. And a broken whistle.\n\n" +
					"Press W to wear the Uniform and pass the guard disguising as another guard" +
					" or press R to return back to the corridor.";
		if 		(Input.GetKeyDown (KeyCode.W))	{myState = States.courtyard;}
		else if (Input.GetKeyDown (KeyCode.R))	{myState = States.corridor_3;}
	}
	void courtyard (){
		text.text = "You made your way up the stairs and passed through the guard without being caught, " +
					"You are now Free! \n\n" +
					"Press P to Play again.";
		if 		(Input.GetKeyDown (KeyCode.P))	{myState = States.cell;}
	}
	#endregion
}